//====================================================================\\
//|                                        CombEA_PCI_5CCI_v_1-03.mq4 ||
//|                                 Copyright  2012.03.16, Alexander ||
//|ICQ: 609928564 | email: I-m-hungree@yandex.ru | skype: i_m_hungree ||
//====================================================================//

#property copyright "Copyright  2012"
#property link      "CombEA_PCI_6CCI_v_1-03 by Im_hungree"

//===================================================================//
extern   string         section1                  =                 "//=========  ";
extern   double         Lot                       = 0.1;             //  
extern   int            Stop_Loss                 = 8500;             // 0 -   
extern   int            Take_Profit               = 9500;             // 0 -   
extern   int            Magic                     = 4444;            //  
extern   int            Slippage                  = 6;               //  
//===================================================================//
extern   string         section2                  =                 "//=========  .";
extern   bool           Use_Time_trade            = true;            //     
extern   int            trade.hour                = 11;               //   
extern   int            trade.min                 = 0;               //   
extern   int            not.hour                  = 18;              //    
extern   int            not.min                   = 0;               //   
//===================================================================//
extern   string         section3                  =                 "//=========  ";
extern   bool           Used_Tral_Stop            = false;            //  
extern   int            Pont_tral_SL              = 500;             //  
//===================================================================//
extern   string         section4                  =                 "//========= PriceChannelStop";
extern   int            PCS_timeframe             = 15;              //   
extern   int            ChannelPeriod             = 11;               // ChannelPeriod
extern   double         Risk                      = 0.30;            // Risk
extern   int            Signal                    = 1;               // Signal
extern   int            Line                      = 1;               // Line
extern   int            Nbars                     = 1000;            // Nbars
extern   double         PCS_wait_signal           = 480;             //     
//===================================================================//
extern   string         section5                  =                 "//=========  1 CCI_Divergence";
extern   int            CCI_timeframe1            = 60;              //   1
extern   int            period1                   = 10;              // period1
extern   int            signalSMA1                = 9;               // signalSMA1
extern   bool           drawIndicatorTrendLines1  = true;            // drawIndicatorTrendLines1
extern   bool           drawPriceTrendLines1      = true;            // drawPriceTrendLines1
extern   bool           displayAlert1             = true;            // displayAlert1
//===================================================================//
extern   string         section6                  =                 "//=========  2 CCI_Divergence";
extern   int            CCI_timeframe2            = 60;              //   2
extern   int            period2                   = 9;              // period2
extern   int            signalSMA2                = 9;               // signalSMA2
extern   bool           drawIndicatorTrendLines2  = true;            // drawIndicatorTrendLines2
extern   bool           drawPriceTrendLines2      = true;            // drawPriceTrendLines2
extern   bool           displayAlert2             = true;            // displayAlert2
//===================================================================//
extern   string         section7                  =                 "//=========  3 CCI_Divergence";
extern   int            CCI_timeframe3            = 60;              //   3
extern   int            period3                   = 8;              // period3
extern   int            signalSMA3                = 9;               // signalSMA3
extern   bool           drawIndicatorTrendLines3  = true;            // drawIndicatorTrendLines3
extern   bool           drawPriceTrendLines3      = true;            // drawPriceTrendLines3
extern   bool           displayAlert3             = true;            // displayAlert3
//===================================================================//
extern   string         section8                  =                 "//=========  4 CCI_Divergence";
extern   int            CCI_timeframe4            = 60;              //   4
extern   int            period4                   = 7;              // period4
extern   int            signalSMA4                = 9;               // signalSMA4
extern   bool           drawIndicatorTrendLines4  = true;            // drawIndicatorTrendLines4
extern   bool           drawPriceTrendLines4      = true;            // drawPriceTrendLines4
extern   bool           displayAlert4             = true;            // displayAlert4
//===================================================================//
extern   string         section9                  =                 "//=========  5 CCI_Divergence";
extern   int            CCI_timeframe5            = 60;              //   5
extern   int            period5                   = 6;              // period5
extern   int            signalSMA5                = 9;               // signalSMA5
extern   bool           drawIndicatorTrendLines5  = true;            // drawIndicatorTrendLines5
extern   bool           drawPriceTrendLines5      = true;            // drawPriceTrendLines5
extern   bool           displayAlert5             = true;            // displayAlert5
//===================================================================//
extern   string         section10                 =                 "//=========  6 CCI_Divergence";
extern   int            CCI_timeframe6            = 60;              //   6
extern   int            period6                   = 6;              // period6
extern   int            signalSMA6                = 9;               // signalSMA6
extern   bool           drawIndicatorTrendLines6  = true;            // drawIndicatorTrendLines6
extern   bool           drawPriceTrendLines6      = true;            // drawPriceTrendLines6
extern   bool           displayAlert6             = true;            // displayAlert6

//===================================================================//
//                         global variables                          ||
//===================================================================//

         double         CCI_Divergence1,
                        CCI_Divergence2,
                        CCI_Divergence3,
                        CCI_Divergence4,
                        CCI_Divergence5,
                        CCI_Divergence6,
                        PriceChannelStop_up,
                        PriceChannelStop_dn,

                        Tral_price;

         datetime       _Time,
                        Time_Wait_sign;

         string         Type;

         bool           flag_CCI_buy              = false,
                        flag_CCI_sell             = false;

//===================================================================//
//                           initialization                          ||
//===================================================================//
int init()
{
//---
}
//===================================================================//
//                          deinitialization                         ||
//===================================================================//
int deinit()
{
         return(0);
}
//===================================================================//
//                        Expert tick function                       ||
//===================================================================//
int start()
{
  datetime           Sve            = iTime(Symbol(), PCS_timeframe, 0);
  if (PCS_timeframe > CCI_timeframe1)
                     Sve            = iTime(Symbol(), CCI_timeframe1, 0);

//-----

  if (Sve > _Time)
   {
    int              total          = Take_orders();
                     _Time          = Sve;
                     Take_Buffer_data();
    if (total == 0 && ((Use_Time_trade && Take_Time_toTrade()) || !Use_Time_trade))
     {
      if (CCI_Divergence1 == 1.0 || CCI_Divergence1 == 2.0 ||
          CCI_Divergence2 == 1.0 || CCI_Divergence2 == 2.0 ||
          CCI_Divergence3 == 1.0 || CCI_Divergence3 == 2.0 ||
          CCI_Divergence4 == 1.0 || CCI_Divergence4 == 2.0 ||
          CCI_Divergence5 == 1.0 || CCI_Divergence5 == 2.0 ||
          CCI_Divergence6 == 1.0 || CCI_Divergence6 == 2.0 ||
          flag_CCI_buy)
       {
        if (!flag_CCI_buy && PCS_wait_signal > 0)
                     Time_Wait_sign = TimeCurrent();
        if ((Time_Wait_sign + (PCS_wait_signal * 60)) >= TimeCurrent())
                     flag_CCI_buy   = false;
                     flag_CCI_buy   = true;
                     flag_CCI_sell  = false;
        if (PriceChannelStop_dn != -1 && PriceChannelStop_up == -1 && flag_CCI_buy)
                     Open_Orders (0);
       }
      if (CCI_Divergence1 == 3.0 || CCI_Divergence1 == 4.0 ||
          CCI_Divergence2 == 3.0 || CCI_Divergence2 == 4.0 ||
          CCI_Divergence3 == 3.0 || CCI_Divergence3 == 4.0 ||
          CCI_Divergence4 == 3.0 || CCI_Divergence4 == 4.0 ||
          CCI_Divergence5 == 3.0 || CCI_Divergence5 == 4.0 ||
          CCI_Divergence6 == 1.0 || CCI_Divergence6 == 2.0 ||
          flag_CCI_sell)
       {
        if (!flag_CCI_sell && PCS_wait_signal > 0)
                     Time_Wait_sign = TimeCurrent();
        if ((Time_Wait_sign + (PCS_wait_signal * 60)) >= TimeCurrent())
                     flag_CCI_sell  = false;
                     flag_CCI_buy   = false;
                     flag_CCI_sell  = true;
        if (PriceChannelStop_dn == -1 && PriceChannelStop_up != -1 && flag_CCI_sell)
                     Open_Orders (1);
       }
     }
    if (total > 0)
     {
      if (Type == "sell")
        if (CCI_Divergence1 == 1.0 || CCI_Divergence1 == 2.0 ||
            CCI_Divergence2 == 1.0 || CCI_Divergence2 == 2.0 ||
            CCI_Divergence3 == 1.0 || CCI_Divergence3 == 2.0 ||
            CCI_Divergence4 == 1.0 || CCI_Divergence4 == 2.0 ||
            CCI_Divergence5 == 1.0 || CCI_Divergence5 == 2.0 ||
            CCI_Divergence6 == 1.0 || CCI_Divergence6 == 2.0 ||
            (PriceChannelStop_dn != -1 && PriceChannelStop_up == -1))
                     Close_Orders();
      if (Type == "buy")
        if (CCI_Divergence1 == 3.0 || CCI_Divergence1 == 4.0 ||
            CCI_Divergence2 == 3.0 || CCI_Divergence2 == 4.0 ||
            CCI_Divergence3 == 3.0 || CCI_Divergence3 == 4.0 ||
            CCI_Divergence4 == 3.0 || CCI_Divergence4 == 4.0 ||
            CCI_Divergence5 == 3.0 || CCI_Divergence5 == 4.0 ||
            CCI_Divergence6 == 1.0 || CCI_Divergence6 == 2.0 ||
            (PriceChannelStop_dn == -1 && PriceChannelStop_up != -1))
                     Close_Orders();
     }
   }

//================= Tral

 if (Used_Tral_Stop == true)
   {
            double   raz            = 0.0;
    if (Type == "buy")
      {
                     raz            = Bid - Pont_tral_SL * Point;
       if (Tral_price == 0.0 || Tral_price < raz)
                     Modif_order(Type, raz);
      }
     if (Type == "sell")
      {
                     raz            = Ask + Pont_tral_SL * Point;
       if (Tral_price == 0.0 || Tral_price > raz)
                     Modif_order(Type, raz);
      }
   }
}
//===================================================================//
//                                                  ||
//===================================================================//
void Take_Buffer_data()
{
    RefreshRates();

//------

    CCI_Divergence1 = iCustom (Symbol(), CCI_timeframe1, "CCI_Divergence_V1q1_mod_2",
                               "*** CCI Settings ***",
                               period1,
                               signalSMA1,
                               "*** Indicator Settings ***",
                               drawIndicatorTrendLines1,
                               drawPriceTrendLines1,
                               displayAlert1,
                               4,1);
    CCI_Divergence2 = iCustom (Symbol(), CCI_timeframe2, "CCI_Divergence_V1q1_mod_2",
                               "*** CCI Settings ***",
                               period2,
                               signalSMA2,
                               "*** Indicator Settings ***",
                               drawIndicatorTrendLines2,
                               drawPriceTrendLines2,
                               displayAlert2,
                               4,1);
    CCI_Divergence3 = iCustom (Symbol(), CCI_timeframe3, "CCI_Divergence_V1q1_mod_2",
                               "*** CCI Settings ***",
                               period3,
                               signalSMA3,
                               "*** Indicator Settings ***",
                               drawIndicatorTrendLines3,
                               drawPriceTrendLines3,
                               displayAlert3,
                               4,1);
    CCI_Divergence4 = iCustom (Symbol(), CCI_timeframe4, "CCI_Divergence_V1q1_mod_2",
                               "*** CCI Settings ***",
                               period4,
                               signalSMA4,
                               "*** Indicator Settings ***",
                               drawIndicatorTrendLines4,
                               drawPriceTrendLines4,
                               displayAlert4,
                               4,1);
    CCI_Divergence5 = iCustom (Symbol(), CCI_timeframe5, "CCI_Divergence_V1q1_mod_2",
                               "*** CCI Settings ***",
                               period5,
                               signalSMA5,
                               "*** Indicator Settings ***",
                               drawIndicatorTrendLines5,
                               drawPriceTrendLines5,
                               displayAlert5,
                               4,1);
    CCI_Divergence6 = iCustom (Symbol(), CCI_timeframe6, "CCI_Divergence_V1q1_mod_2",
                               "*** CCI Settings ***",
                               period6,
                               signalSMA6,
                               "*** Indicator Settings ***",
                               drawIndicatorTrendLines6,
                               drawPriceTrendLines6,
                               displayAlert6,
                               4,1);

//----------

    PriceChannelStop_dn = iCustom (Symbol(), PCS_timeframe, "PriceChannel_Stop_v1__1",
                               ChannelPeriod,
                               Risk,
                               Signal,
                               Line,
                               Nbars,
                               0,0);
    PriceChannelStop_up = iCustom (Symbol(), PCS_timeframe, "PriceChannel_Stop_v1__1",
                               ChannelPeriod,
                               Risk,
                               Signal,
                               Line,
                               Nbars,
                               1,0);
}
//===================================================================//
//                                                      ||
//===================================================================//
int Take_orders()
{
  int       tt;
            Type           = "no";
  for(int i = OrdersTotal() - 1; i >= 0 ; i--)
   {
    if(OrderSelect(i,SELECT_BY_POS))
     {
       if(OrderType() < 2 && OrderMagicNumber() == Magic)
        {
            tt            +=1;
         if (OrderType() == OP_BUY)
            Type           = "buy";
         if (OrderType() == OP_SELL)
            Type           = "sell";
        }
     }
   }
            return (tt);
}
//===================================================================//
//                                                           ||
//===================================================================//
void Open_Orders (int  sym  = -1)
{
  int         ticket,
              cmd,
              error;
  double      Price;

//==============     

  if (sym == 0)
   {
              Price            = NormalizeDouble(Ask, Digits);
              cmd              = 0;
   }
  if (sym == 1)
   {
              Price            = NormalizeDouble(Bid, Digits);
              cmd              = 1;
   }

//========   

              ticket           = OrderSend(Symbol(), cmd, Lot, Price, Slippage, 0, 0, "", Magic, 0, Blue);
  if(ticket == -1)
   {
              error            =  GetLastError();
              Print ("  = ", error);
      if (error != 1)
              Take_error(error);
   }
  else
   {
    if (Stop_Loss > 0.0 || Take_Profit > 0.0)
     {
      if (OrderSelect(OrdersTotal() - 1, SELECT_BY_POS) == true)
       {  
        if (OrderType() < 2 && OrderMagicNumber() == Magic)
         {
              ticket           = OrderTicket();
         int  dig              = MarketInfo(Symbol(),MODE_DIGITS),
              err;
         double _Open          = OrderOpenPrice(),
              SL               = 0,
              TP               = 0;

       //-------

          if (sym == 0)
           {
            if (Stop_Loss > 0)
              SL               = NormalizeDouble((_Open - Stop_Loss * Point), Digits);
            if (Take_Profit > 0)
              TP               = NormalizeDouble((_Open + Take_Profit * Point), Digits);
           }
          if (sym == 1)
           {
            if (Stop_Loss > 0)
              SL               = NormalizeDouble((_Open + Stop_Loss * Point), Digits);
            if (Take_Profit > 0)
              TP               = NormalizeDouble((_Open - Take_Profit * Point), Digits);
           }

       //-------

          bool error1          = OrderModify(ticket,_Open,SL,TP,0,White);
          if (!error1 && error1 != 1)
           {
              err              = GetLastError();
              Take_error(err);
              Print("Error order=",ticket," err= ",err," ",Symbol(),"SL=",SL);
           }
         }
       }
     }
              Tral_price = SL;
              flag_CCI_buy     = false;
              flag_CCI_sell    = false;
   }
}
//===================================================================//
//                                                     ||
//===================================================================//
void Modif_order( string  top = "no", double _sl  = 0)
{
  for (int i=0; i<OrdersTotal(); i++) 
   {  
    if (OrderSelect(i, SELECT_BY_POS) == true)
     {  
      if (OrderType() < 2 && OrderMagicNumber() == Magic)
       {
        int      ticket     = OrderTicket(),
                 dig        = MarketInfo(Symbol(),MODE_DIGITS),
                 err;
        double   _Open      = OrderOpenPrice(),
                 SL         = _sl,
                 TP         = OrderTakeProfit();

//========    

        if (top == "buy" && _sl == 0.0)
         {
          if (Stop_Loss > 0)
                  SL        = NormalizeDouble((_Open - Stop_Loss * Point), Digits);
          if (Take_Profit > 0)
                  TP        = NormalizeDouble((_Open + Take_Profit * Point), Digits);
         }
        if (top == "sell" && _sl == 0.0)
         {
          if (Stop_Loss > 0)
                  SL        = NormalizeDouble((_Open + Stop_Loss * Point), Digits);
          if (Take_Profit > 0)
                  TP        = NormalizeDouble((_Open - Take_Profit * Point), Digits);
         }

//========

        bool     error1     = OrderModify(ticket,_Open,SL,TP,0,White);
        if (!error1 && error1 != 1)
          {
                 err        = GetLastError();
                 Take_error(err);
                 Print("Error order=",ticket," err= ",err," ",Symbol(),"SL=",SL);
          }
        else
                 Tral_price = SL;
       }
     }   
   }
}
//===================================================================//
//                            Close orders                           ||
//===================================================================//
void Close_Orders ()
{
  if(OrdersTotal() == 0)
                 return;
  int            close_error;
  while (Take_orders() > 0)
   {
    for(int i = 0; i < OrdersTotal(); i++) 
     {
      if(OrderSelect(i,SELECT_BY_POS) && OrderMagicNumber() == Magic)
       {
          if(OrderType() == OP_BUY)
           {
            if(!OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,CLR_NONE))
             {
                 close_error       = GetLastError();
               if (close_error != 1)
                 Take_error(close_error);
             }
           }
          if(OrderType() == OP_SELL)
           {
            if(!OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,CLR_NONE))
             {
                 close_error       = GetLastError();
               if (close_error != 1)
                 Take_error(close_error);
             } 
           }
       }
     }
   }
}
//===================================================================//
//                             Find errors                           ||
//===================================================================//
void Take_error (int  _err)
{
      if (_err==1)    Alert (" ,   ");
      if (_err==2)    Alert (" ");
      if (_err==3)    Alert (" ");
      if (_err==4)    Alert ("  ");
      if (_err==5)    Alert ("   ");
      if (_err==6)    Alert ("    ");
      if (_err==7)    Alert (" ");
      if (_err==8)    Alert ("  ");
      if (_err==9)    Alert ("    ");
      if (_err==64)   Alert (" ");
      if (_err==65)   Alert ("  ");
      if (_err==128)  Alert ("    ");
      if (_err==129)  Alert (" ");
      if (_err==130)  Alert (" ");
      if (_err==131)  Alert (" ");
      if (_err==132)  Alert (" ");
      if (_err==133)  Alert (" ");
      if (_err==134)  Alert ("    ");
      if (_err==135)  Alert (" ");
      if (_err==136)  Alert (" ");
      if (_err==137)  Alert (" ");
      if (_err==138)  Alert ("  - ");
      if (_err==139)  Alert ("    ...");
      if (_err==140)  Alert ("   ...");
      if (_err==141)  Alert ("  ");
      if (_err==145)  Alert (" ,       ");
      if (_err==146)  Alert ("  ");
      if (_err==147)  Alert ("     ");
      if (_err==148)  Alert ("      ");
      if (_err==149)  Alert (" ");
      if (_err==150)  Alert ("  FIFO");
//------
      if (_err==4000) Alert (" ");
      if (_err==4001) Alert ("  ");
      if (_err==4002) Alert ("  -  ");
      if (_err==4003) Alert ("    ");
      if (_err==4004) Alert ("    ");
      if (_err==4005) Alert ("      ");
      if (_err==4006) Alert ("    ");
      if (_err==4007) Alert ("    ");
      if (_err==4008) Alert (" ");
      if (_err==4009) Alert ("   ");
      if (_err==4010) Alert ("    ");
      if (_err==4011) Alert ("  ");
      if (_err==4012) Alert ("    ");
      if (_err==4013) Alert ("  ");
      if (_err==4014) Alert (" ");
      if (_err==4015) Alert (" ");
      if (_err==4016) Alert (" ");
      if (_err==4017) Alert (" DLL  ");
      if (_err==4018) Alert ("  ");
      if (_err==4019) Alert ("  ");
      if (_err==4020) Alert ("     ");
      if (_err==4021) Alert ("   ,   ");
      if (_err==4022) Alert (" ");
      if (_err==4050) Alert ("   ");
      if (_err==4051) Alert ("   ");
      if (_err==4052) Alert ("   ");
      if (_err==4053) Alert (" ");
      if (_err==4054) Alert ("  -");
      if (_err==4055) Alert ("  ");
      if (_err==4056) Alert (" ");
      if (_err==4057) Alert ("   ");
      if (_err==4058) Alert ("   ");
      if (_err==4059) Alert ("     ");
      if (_err==4060) Alert ("  ");
      if (_err==4061) Alert ("  ");
      if (_err==4062) Alert ("   string");
      if (_err==4063) Alert ("   integer");
      if (_err==4064) Alert ("   double");
      if (_err==4065) Alert ("    ");
      if (_err==4066) Alert ("     ");
      if (_err==4067) Alert ("    ");
      if (_err==4099) Alert (" ");
      if (_err==4100) Alert ("    ");
      if (_err==4101) Alert ("  ");
      if (_err==4102) Alert ("   ");
      if (_err==4103) Alert ("  ");
      if (_err==4104) Alert ("    ");
      if (_err==4105) Alert ("    ");
      if (_err==4106) Alert (" ");
      if (_err==4107) Alert ("     ");
      if (_err==4108) Alert ("  ");
      if (_err==4109) Alert ("  ");
      if (_err==4110) Alert ("   ");
      if (_err==4111) Alert ("   ");
      if (_err==4200) Alert ("  ");
      if (_err==4201) Alert ("   ");
      if (_err==4202) Alert ("  ");
      if (_err==4203) Alert ("  ");
      if (_err==4204) Alert ("  ");
      if (_err==4205) Alert ("  ");
      if (_err==4206) Alert ("   ");
      if (_err==4207) Alert ("    ");
      if (_err==0)    Alert (" ");

      if (_err==128 || _err==142 || _err==143)
                       Sleep (44000);
      if (_err == 6 || _err == 5)
                       Sleep (293000);
      if (_err == 129)
                       Sleep (3400);
      if (_err == 4 || _err == 131 || _err == 132)
                       Sleep (287000);
      if (_err == 8 || _err == 141)
                       Sleep (101000);
      if (_err == 139)
                       Sleep (254000);
      if (_err == 146)
                       Sleep (11000);
      if (_err != 135  && _err != 138)
                       Sleep (3500);
}
//===================================================================//
//                                                              ||
//===================================================================//
bool Take_Time_toTrade() 
{
      datetime   Start   = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+" "+trade.hour+":"+trade.min);
      datetime   End     = StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+" "+not.hour+":"+not.min);
      int        NowTime = TimeHour(TimeCurrent());
      if (Start >= End)
        {
         if (NowTime >= not.hour)
                 End    += 86400;
         else
                 Start  -= 86400;
        }
      if (TimeCurrent() >= Start && TimeCurrent() <= End)
                           return(true);
      else
                           return(false);
                           return(false);
}